unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.DBGrids,
  Vcl.StdCtrls, Data.DB, Vcl.Grids, Data.Win.ADODB, ekbasereport, ekrtf;

type
  TForm1 = class(TForm)
    cn: TADOConnection;
    Customers: TADOTable;
    DBGrid1: TDBGrid;
    Customers_Source: TDataSource;
    Button1: TButton;
    Label1: TLabel;
    Button2: TButton;
    Button3: TButton;
    EkRTF1: TEkRTF;
    DBDialog: TOpenDialog;
    RTFDialog: TOpenDialog;
    Orders: TADOTable;
    Orders_Source: TDataSource;
    DBGrid2: TDBGrid;
    Label2: TLabel;
    Qr: TADOQuery;
    DBGrid3: TDBGrid;
    DataSource1: TDataSource;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
        dbname:string;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
    connection_str1:string;
begin
  cn.Connected := false;
  connection_str1 := 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source=';
  dbname := 'NWind.mdb';
  if not FileExists(dbname) then
  begin
    if DBDialog.Execute then begin
       dbname := DBDialog.FileName;
    end else exit;
  end;
  Form1.Caption := dbname;
  connection_str1 := connection_str1 + dbname + ';Persist Security Info=False';

  cn.ConnectionString := connection_str1;
  Customers.Active := True;
  Orders.Active := True;

  Button2.Enabled := true;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  (* check report template file *)
  if not FileExists(EkRTF1.InFile) then
  begin
    if RTFDialog.Execute then begin
       EkRTF1.InFile := RTFDialog.FileName;
    end else exit;
  end;

  (* create report *)
  Qr.Close;
  Qr.Parameters.ParamByName('OrderID').Value := Orders.FieldByName('OrderID').AsInteger;
  Qr.Open;
  EkRtf1.OutFile := 'EK_RTF_NW_Invoice_' + Orders.FieldByName('OrderID').AsString + '.doc';
  EkRtf1.ExecuteOpen([Qr],SW_SHOW);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
Qr.Close;
Form1.Close;
end;

end.
